
var comp = 
{
	props:
	{
		data:
		{
			type:[Object,Array],
			required:true
		},
		fields:
		{
			type:[Object,Array],
			required:true
		},
		heading:
		{
			type:[String],
			required:false,
			default:""
		},
		place_holder:
		{
			type:String,
			required:false,
			default:"search here..."
		},
		add:
		{
			type:Boolean,
			default:false
		},
		refreshed:
		{
			type:Boolean,
			default:true
		}
	},
	computed: 
	{
		hasData()
		{
			var d = this.data;
			var keys = d? Object.keys(d):[];
			return keys.length!=0;
		},
	},
	watch:
	{
		search_phrase(val)
		{
			this.$emit('searchChanged',val);
			
		},
		refreshed(val)
		{
			if(val)
			{
				this.requestFetch();
				this.$emit("refreshed","list_refresh");
			}
		}
	},
	data() 
	{ 
		return {
			search_phrase:"",
			selected_rows:[],
			edit:"edit",
			page:0,
			page_size: 40
		};
	},
	async mounted()
	{
		this.$emit('listStart',this);
		this.requestFetch();
		this.$root.vHook(this,"refresh_list",()=>this.requestFetch());
	},
	methods:
	{
		headerName(key)
		{
			return key+"_header";

		},
		pageLeft()
		{
			if(this.page>0)
			{
				this.page--;
				this.requestFetch();
			}
		},
		pageRight()
		{
			this.page++;
			this.requestFetch();
		},
		searchKeyUp()
		{
			this.page = 0;
			this.requestFetch();
		},
		requestFetch()
		{
			var request = 
			{
				search:this.search_phrase,
				search_fields:this.search_fields,
				limit:this.page_size+"",
				offset:(this.page * this.page_size)+"",
			}
			this.$emit("fetch",request);
		},
		getPage()
		{
			var p = this.page || 0;
			var ps = this.page_size || 40;
			
			var cur = p*ps;
			var next = cur + ps -1;
			
			return (cur==0?1:cur) + " to "+ next;
		},
		listItemClass(index)
		{
			return "COMP__cell COMP__row"+(index % 2 ? "" : "_alt");
		},
		rowSelect(row)
		{
			this.$emit('rowSelected',row);
		},
		rowAdd()
		{
			this.$emit('rowAdd');
		}
	}
};
