<?php

function buildTables()
{
    $db = new Mysql("tstreats_db");

    $response["db"] = $db-> buildDb();
    $response["auth"] = buildAuthTable($db);
    $response["client"] = buildClientsTable($db);
    $response["order"] = buildOrderTable($db);
    $response["client_order"] = buildClientOrderTable($db);
    $response["user"] = buildUserTable($db);
    $response["user_client"] = buildUserClientTable($db);
    $response["contact_us"] = buildContactUsTable($db);
    
    // $response["shop_items"] = buildShopTable($db);
    // $response["link_order"]= buildLink($db,"order_info");
    // $response["link_client"]= buildLink($db,"client");

    
    return $response;
}

function buildAuthTable($db)
{
    $fields=[];
    array_push($fields, "auth_hash VARCHAR(40) NOT NULL");
    array_push($fields, "auth_created DATETIME");
    array_push($fields, "auth_logged_in DATETIME");
    array_push($fields, "auth_deleted VARCHAR(64)");
    array_push($fields, "user_id VARCHAR(64)");

    return  $db-> buildTable("auth",$fields);
}

function buildClientsTable($db)
{
    $fields=[];
    array_push($fields, "first_name VARCHAR(256) NOT NULL");
    array_push($fields, "last_name VARCHAR(256)");
    array_push($fields, "email_address VARCHAR(256)");
    array_push($fields, "contact_number VARCHAR(256)");
    array_push($fields, "address VARCHAR(256) default 'n/a'");
    array_push($fields, "add_to_whatsapp_group VARCHAR(256)");

    return  $db-> buildTable("client",$fields);
}

function buildOrderTable($db)
{
    $fields=[];
    array_push($fields, "order_number VARCHAR(7)");
    array_push($fields, "date_order VARCHAR(20)");
    array_push($fields, "pic_del_date VARCHAR(20)");
    array_push($fields, "pic_del VARCHAR(20)");
    array_push($fields, "order_cancelled VARCHAR(1)");
    array_push($fields, "payment_type VARCHAR(20)");
    array_push($fields, "data JSON");

    return  $db-> buildTable("order_info",$fields);
}

function buildClientOrderTable($db)
{
    $fields=[];
    array_push($fields,"client_id VARCHAR(64) NOT NULL");
    array_push($fields,"order_id VARCHAR(64) NOT NULL");

    return  $db-> buildTable("client_order",$fields);
}

function buildUserTable($db)
{
    $fields=[];
    array_push($fields,"user_name VARCHAR(64) NOT NULL");
    array_push($fields,"user_pass VARCHAR(64) NOT NULL");

    return  $db-> buildTable("user",$fields);
}

function buildUserClientTable($db)
{
    $fields=[];
    array_push($fields,"client_id VARCHAR(64) NOT NULL");
    array_push($fields,"user_id VARCHAR(64) NOT NULL");

    return  $db-> buildTable("user_client",$fields);
}

function buildContactUsTable($db)
{
    $fields=[];
    array_push($fields,"name VARCHAR(64) NOT NULL");
    array_push($fields,"email VARCHAR(64) NOT NULL");
    array_push($fields,"number VARCHAR(64) NOT NULL");
    array_push($fields,"message VARCHAR(10000) NOT NULL");

    return  $db-> buildTable("contact_us",$fields);
}

// function buildShopTable($db)
// {
//     $fields=[];
//     array_push($fields,"flavor VARCHAR(256) NOT NULL");
//     array_push($fields,"size VARCHAR(256)");
//     array_push($fields, "price VARCHAR(256)");
//     array_push($fields, "image_url VARCHAR(256)");

//     return  $db-> buildTable("shop_items",$fields);
// }


// function buildLink($db,$parent_type)
// {
//     $fields=[];
//     array_push($fields,"parent_id VARCHAR(64) NOT NULL");
//     array_push($fields,"child_id VARCHAR(64) NOT NULL");
//     array_push($fields,"child_type VARCHAR(256) NOT NULL");
//     array_push($fields,"data JSON ");
//     return  $db-> buildTable($parent_type."_link",$fields);
// }
